src/Entity/Actualite.php
<?php

namespace App\Entity;

use App\Repository\ActualiteRepository;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

#[ORM\Entity(repositoryClass: ActualiteRepository::class)]
class Actualite
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column(type: 'integer')]
    private $id;

    #[ORM\Column(type: 'string', length: 50, nullable: true)]
    private $titre_art;

    #[ORM\Column(type: 'date', nullable: true)]
    private $date_art;

    #[ORM\Column(type: 'text', nullable: true)]
    private $description_art;

    #[ORM\Column(type: 'string', length: 255, nullable: true)]
    private $image_actu;

    public function __construct(){
        $this->date_art = new \DateTimeImmutable();
    }


    public function getId(): ?int
    {
        return $this->id;
    }

    public function getTitreArt(): ?string
    {
        return $this->titre_art;
    }

    public function setTitreArt(?string $titre_art): self
    {
        $this->titre_art = $titre_art;

        return $this;
    }

    public function getDateArt(): ?\DateTimeInterface
    {
        return $this->date_art;
    }

    public function setDateArt(?\DateTimeInterface $date_art): self
    {
        $this->date_art = $date_art;

        return $this;
    }

    public function getDescriptionArt(): ?string
    {
        return $this->description_art;
    }

    public function setDescriptionArt(?string $description_art): self
    {
        $this->description_art = $description_art;

        return $this;
    }

    public function getImageActu(): ?string
    {
        return $this->image_actu;
    }

    public function setImageActu(?string $image_actu): self
    {
        $this->image_actu = $image_actu;

        return $this;
    }

}

src/Form/ActualiteType.php
<?php

namespace App\Form;

use App\Entity\Actualite;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\FileType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Component\Validator\Constraints\File;

class ActualiteType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('titre_art', TextType::class, [
                'attr' => [
                    'class' => 'title-actu',
                    'min' => '3',
                    'max' => '255'
                ],
                'label' => 'Titre',
                'label_attr' => [
                    'class' => 'label'
                ],
                'constraints' => [
                    new Assert\Length(['min' => 3, 'max' => 255]),
                    new Assert\NotBlank([
                        'message' => "Veuillez renseigner le titre de l'article",
                    ])
                ]
            ])
            ->add('image_actu', FileType::class, [
                'mapped'=> false,
                'attr' => [
                    'class' => 'img-actu',
                ],
                'label' => 'Image', 'required' => false,
                'label_attr' => [
                    'class' => 'label'
                ], 'constraints' => [
                    new File([
                        'mimeTypes' => ['image/*']
                    ])
                ]
            ])
            ->add('description_art', TextareaType::class, [
                'attr' => [
                    'class' => 'descr-actu',
                    'min' => '10',
                    'max' => '1500'
                ],
                'label' => 'Description',
                'label_attr' => [
                    'class' => 'label'
                ],
                'constraints' => [
                    new Assert\Length(['min' => 10, 'max' => 1500]),
                    new Assert\NotBlank()
                ]
            ])

        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Actualite::class,
        ]);
    }
}

src/Controller/ActualiteController.php
<?php

namespace App\Controller;

use App\Entity\Actualite;
use App\Form\ActualiteType;
use App\Repository\ActualiteRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Security;
use Knp\Component\Pager\PaginatorInterface;
use App\Service\FileUploader;

#[Route('/actualite')]
class ActualiteController extends AbstractController
{
    #[Route('/', name: 'app_actualite_index', methods: ['GET'])]
    public function index(ActualiteRepository $actualiteRepository, PaginatorInterface $paginator, Request $request): Response
    {
        $actualites = $paginator->paginate(
            $actualiteRepository->findAll(),
            $request->query->getInt('page', 1), /*page number*/
            3 /*limit per page*/
        );

        return $this->render('actualite/index.html.twig', [
            'actualites' => $actualites,
        ]);
    }
    #[Security("is_granted('ROLE_ADMIN')")]
    #[Route('/new', name: 'app_actualite_new', methods: ['GET', 'POST'])]
    public function new(Request $request, FileUploader $fileUploader, ActualiteRepository $actualiteRepository): Response
    {

        $actualite = new Actualite();
        $form = $this->createForm(ActualiteType::class, $actualite);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $imageFile = $form->get('image_actu')->getData();
            if ($imageFile) {
                $imageFileName = $fileUploader->upload($imageFile);
                $actualite->setImageActu($imageFileName);
            }
            
            $actualiteRepository->add($actualite);
            return $this->redirectToRoute('app_actualite_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('actualite/new.html.twig', [
            'actualite' => $actualite,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'app_actualite_show', methods: ['GET'])]
    public function show(Actualite $actualite): Response
    {
        return $this->render('actualite/show.html.twig', [
            'actualite' => $actualite,
        ]);
    }
    #[Security("is_granted('ROLE_ADMIN')")]
    #[Route('/{id}/edit', name: 'app_actualite_edit', methods: ['GET', 'POST'])]
    public function edit(Request $request, FileUploader $fileUploader, Actualite $actualite, ActualiteRepository $actualiteRepository): Response
    {
        $form = $this->createForm(ActualiteType::class, $actualite);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $imageFile = $form->get('image_actu')->getData();
            if ($imageFile) {
                $imageFileName = $fileUploader->upload($imageFile);
                $actualite->setImageActu($imageFileName);
            }
            $actualiteRepository->add($actualite);
            return $this->redirectToRoute('app_actualite_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('actualite/edit.html.twig', [
            'actualite' => $actualite,
            'form' => $form,
        ]);
    }
    #[Security("is_granted('ROLE_ADMIN')")]
    #[Route('/delete/{id}', name: 'app_actualite_delete', methods: ['GET'])]
    public function delete(Request $request, Actualite $actualite, ActualiteRepository $actualiteRepository): Response
    {
        // if ($this->isCsrfTokenValid('delete'.$actualite->getId(), $request->request->get('_token'))) {
            $actualiteRepository->remove($actualite);
        // }

        return $this->redirectToRoute('app_actualite_index', [], Response::HTTP_SEE_OTHER);
    }
}

templates/actualite/_delete_form.html.twig
<form method="post" action="{{ path('app_actualite_delete', {'id': actualite.id}) }}" onsubmit="return confirm('Êtes-vous sûr de vouloir supprimer?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ actualite.id) }}">
    <button class="del">Supprimer</button>
</form>

templates/actualite/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn">{{ button_label|default('Sauvegarder') }}</button>
{{ form_end(form) }}

templates/actualite/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Modifier l'actualité{% endblock %}

{% block body %}
    <h1>Modifier l'actualité</h1>

    {{ include('actualite/_form.html.twig', {'button_label': 'Sauvegarder'}) }}

    <a href="{{ path('app_actualite_index') }}">Retour</a>


{% endblock %}

templates/actualite/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}
	Actualités

{% endblock %}

{% block stylesheets %}
	<style>
		.pagination {
			display: inline-block;
		}

		.pagination a {
			color: #F9F617;
			padding: 8px 16px;
			text-decoration: none;
			background-color: #000000;
			transition: background-color 0.3s;
			border: 1px solid #ddd;
		}

		.current {
			color: #000000;
			padding: 8px 16px;
			text-decoration: none;
			background-color: #F9F617;
			transition: background-color 0.3s;
			border: 1px solid #ddd;
		}

		.pagination a.active {
			background-color: #4CAF50;
			color: white;
			border: 1px solid #4CAF50;
		}

		.pagination a:hover:not(.active) {
			background-color: #F9F617;
			color: black;
		}
	</style>
{% endblock %}

{% block body %}

	<main class="mainActu">
		<div class="news">
			<p class="titreActu">
				Dernières actualités
			</p>
		</div>

		{% if is_granted('ROLE_ADMIN') %}
			<a href="{{ path('app_actualite_new') }}">
				<i class="fa-solid fa-file-circle-plus fa-2x" style="color:black"></i>
			</a>
		{% endif %}

		{% for actualite in actualites %}
			<div class="containerNewArticle">
				<div class="border"></div>
				{% if is_granted('ROLE_ADMIN') %}
				<div class="input-admin">
                    <a title="Supprimer" href="{{ path('app_actualite_delete', {'id': actualite.id}) }}"><i class="fa-solid fa-trash fa-2x" style="color:black"></i></a>
					<a href="{{ path('app_actualite_edit', {'id': actualite.id}) }}">
						<i class="fa-solid fa-file-pen fa-2x" style="color:black"></i>
					</a>
				</div>
				{% endif %}
				<p class="titreActu2">
					{{ actualite.titreArt }}
				</p>
				<p class="dateActu">
					<small>Publié le :
						{{ actualite.dateArt  ? actualite.dateArt |date('Y-m-d') : '' }}
					</small>
				</p>
				<img class="imgActu" src="/uploads/{{ actualite.imageActu }}" alt="{{ actualite.titreArt }}">
				<p class="textActu">
					{{ actualite.descriptionArt }}
				</p>
			</div>
		{% else %}
			<p>
				Aucune actualité, veuillez en créer de nouvelles
			</p>
		{% endfor %}

		<div class="navigation">
			{{ knp_pagination_render(actualites) }}
		</div>

	</main>

{% endblock %}

templates/actualite/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}Créer une nouvelle actualité{% endblock %}

{% block body %}
    <h1>Créer une nouvelle actualité</h1>

    {{ include('actualite/_form.html.twig') }}

    <a href="{{ path('app_actualite_index') }}">Retour</a>
{% endblock %}

templates/actualite/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Actualite{% endblock %}

{% block body %}
    <h1>Actualite</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ actualite.id }}</td>
            </tr>
            <tr>
                <th>Titre_art</th>
                <td>{{ actualite.titreArt }}</td>
            </tr>
            <tr>
                <th>Date_art</th>
                <td>{{ actualite.dateArt ? actualite.dateArt|date('Y-m-d') : '' }}</td>
            </tr>
            <tr>
                <th>Description_art</th>
                <td>{{ actualite.descriptionArt }}</td>
            </tr>
            <tr>
                <th>Visibilite_art</th>
                <td>{{ actualite.visibiliteArt ? 'Yes' : 'No' }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('app_actualite_index') }}">back to list</a>

    <a href="{{ path('app_actualite_edit', {'id': actualite.id}) }}">edit</a>

    {{ include('actualite/_delete_form.html.twig') }}
{% endblock %}